- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# tbb::graph Class Reference

The graph class. More...

`#include <graph.h>`

List of all members.

## Public Types
| unlimited = 0
| serial = 1
enum | concurrency { unlimited = 0, serial = 1 }
| An enumeration the provides the two most common concurrency levels: unlimited and serial.
## Public Member Functions
| graph ()
| Constructs a graph withy no nodes.
| ~graph ()
| Destroys the graph.
void | increment_wait_count ()
| Used to register that an external entity may still interact with the graph.
void | decrement_wait_count ()
| Deregisters an external entity that may have interacted with the graph.
template<typename Receiver, typename Body>
void | run (Receiver &r, Body body)
| Spawns a task that runs a body and puts its output to a specific receiver.
template<typename Body>
void | run (Body body)
| Spawns a task that runs a function object.
void | wait_for_all ()
| Waits until the graph is idle and the number of decrement_wait_count calls equals the number of increment_wait_count calls.
task * | root_task ()
| Returns the root task of the graph.
## Classes
class | run_and_put_task
class | run_task

## Detailed Description

The graph class.

This class serves as a handle to the graph

## Constructor & Destructor Documentation

tbb::graph::~graph | ( |  | ) | `[inline]`

Destroys the graph.

Calls wait_for_all on the graph, deletes all of the nodes appended by calls to add, and then destroys the root task of the graph.

## Member Function Documentation

void tbb::graph::decrement_wait_count | ( |  | ) | `[inline]`

Deregisters an external entity that may have interacted with the graph.

The graph will not return from wait_for_all until all the number of decrement_wait_count calls matches the number of increment_wait_count calls.

void tbb::graph::increment_wait_count | ( |  | ) | `[inline]`

Used to register that an external entity may still interact with the graph.

The graph will not return from wait_for_all until a matching number of decrement_wait_count calls is made.

template<typename Body>

void tbb::graph::run | ( | Body | body | ) | `[inline]`

Spawns a task that runs a function object.

The task is spawned as a child of the graph. This is useful for running tasks that need to block a wait_for_all() on the graph. For example a one-off source.

template<typename Receiver, typename Body>

void tbb::graph::run | ( | Receiver & | r,
|  | Body | body |
| ) |  |  | `[inline]`

Spawns a task that runs a body and puts its output to a specific receiver.

The task is spawned as a child of the graph. This is useful for running tasks that need to block a wait_for_all() on the graph. For example a one-off source.

void tbb::graph::wait_for_all | ( |  | ) | `[inline]`

Waits until the graph is idle and the number of decrement_wait_count calls equals the number of increment_wait_count calls.

The waiting thread will go off and steal work while it is block in the wait_for_all.

The documentation for this class was generated from the following file:

- graph.h

Copyright © 2005-2011 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.